//外部ファイルの読み込み
importScripts("../javascript/Math.js");  
onmessage = function (event) {
	//ホストプログラムから渡された変数の取得
	var parameter = event.data; 
	var step = parameter.step;
	var Step = parameter.Step;
	var x_min = parameter.x_min;
	var x_max = parameter.x_max;
	var dt = parameter.dt;
	var D = parameter.D;
	var N = parameter.N;
	var M = parameter.M;
	//展開係数
	var a = parameter.a; 
	var b = parameter.b;

	function calculate(step) {
		var time = dt * step;
		var L = x_max - x_min;
		var Delta_x = (x_max - x_min) / N;
		var data = [];
		for (var n = 0; n <= N; n++) {
			var x = x_min + Delta_x * n;  //xの値
			var y = a[0] / 2;
			for (var m = 1; m <= M; m++) {
				y += (a[m] * cos(2 * PI * m / L * x) + b[m] * sin(2 * PI * m / L * x)) * exp(-(2 * Math.PI * m / L) * (2 * Math.PI * m / L) * D * time);
			}
			//描画点データの格納
			data.push([x, y]);
		}
		//「pushData」メソッドによるデータの追加
		return data;
	}
	var data = calculate(step);
	//ホストプログラムへ計算結果を送信
	postMessage({ step: step, data:data});
}
