//外部ファイルの読み込み
importScripts("../javascript/Math.js");  
onmessage = function (event) {
	//ホストプログラムから渡された変数の取得
	var parameter = event.data; 
	var step = parameter.step;
	var Step = parameter.Step;
	var x_min = parameter.x_min;
	var x_max = parameter.x_max;
	var dt = parameter.dt;
	var v = parameter.v;
	var N = parameter.N;
	var M = parameter.M;
	//展開係数
	var a = parameter.a; 
	var b = parameter.b;
	var c = parameter.c; 
	var d = parameter.d;
	//境界条件
	var BC = parameter.BC;

	function calculate(step) {
		var time = dt * step;
		var L = x_max - x_min;
		var Delta_x = (x_max - x_min) / N;
		var data = [];
		for (var n = 0; n <= N; n++) {
			var x = x_min + Delta_x * n;  //xの値
			var y = a[0] / 2;
			for (var m = 1; m <= M; m++) {
				var k = 2 * PI * m / L;
				var kh = 2 * PI * (m-1/2) / L;
				var omega = k * v;
				var omegah = kh * v;
				if(BC == "Periodic") {
					y += (a[m] * cos(k * x) + b[m] * sin(k * x)) * cos(omega * time) + (c[m] * cos(k * x) + d[m] * sin(k * x)) * sin(omega * time);
				} else if(BC == "Dirichlet"){
					y += (a[m] * cos(kh * x)* cos(omegah * time) + b[m] * sin(k * x)* cos(omega * time))  + (c[m] * cos(kh * x) * sin(omegah * time) + d[m] * sin(k * x) * sin(omega * time));
				}else if(BC == "Neumann") {
					y += (a[m] * cos(k * x)* cos(omega * time) + b[m] * sin(kh * x)* cos(omegah * time))  + (c[m] * cos(k * x) * sin(omega * time)+ d[m] * sin(kh * x)* sin(omegah * time));
				}
			}
			//描画点データの格納
			data.push([x, y]);
		}
		//「pushData」メソッドによるデータの追加
		return data;
	}
	var data = calculate(step);
	//ホストプログラムへ計算結果を送信
	postMessage({ step: step, data:data});
}
