//外部ファイルの読み込み
importScripts("../javascript/Math.js");  
onmessage = function (event) {
	//ホストプログラムから渡された変数の取得
	var parameter = event.data; 
	var x_min = parameter.x_min;
	var x_max = parameter.x_max;
	var M = parameter.M;
	var m = parameter.m;
	var text_function = parameter.text_function;
	
	//周期
	var L = x_max - x_min;
	//元の関数の定義
	function f(x) {
		var y = 0;
		eval(text_function);
		return y;
	}
	//非積分関数の定義（a係数の計算用）
	function fa(x, n) {
		return f(x) * cos(2 * PI * n / L * x);
	}
	//非積分関数の定義（b係数の計算用）
	function fb(x, n) {
		return f(x) * sin(2 * PI * n / L * x);
	}

	//////////////  初期条件から展開係数の取得	///////////////////
	var MN = M * 4;    //積分→和の分割数
	var Delta_x = (x_max - x_min) / MN;//刻み幅
	//展開係数
	var An=0;
	var Bn=0;
	//シンプソンの公式による数値積分
	for (var n = 1; n <= MN / 2; n++) {
		var x = x_min + Delta_x * (2 * n - 1);
		An += (fa(x - Delta_x, m) + 4 * fa(x, m) + fa(x + Delta_x, m)) / 3 * Delta_x;
		Bn += (fb(x - Delta_x, m) + 4 * fb(x, m) + fb(x + Delta_x, m)) / 3 * Delta_x;
	}
	An *= 2 / L;
	Bn *= 2 / L;
	
	//ホストプログラムへ計算結果を送信
	postMessage({ m: m, An:An, Bn:Bn });
}
