//外部ファイルの読み込み
importScripts("../javascript/Math.js");  
onmessage = function (event) {
	//ホストプログラムから渡された変数の取得
	var parameter = event.data; 
	var x_min = parameter.x_min;
	var x_max = parameter.x_max;
	var M = parameter.M;
	var m = parameter.m;
	var v = parameter.v;
	var BC = parameter.BC;
	var text_function = parameter.text_function;
	var text_function2 = parameter.text_function2;
	
	//周期
	var L = x_max - x_min;
	//元の関数の定義
	function f(x) {
		var y = 0;
		eval(text_function);
		return y;
	}
	//元の関数の定義
	function g(x) {
		var v = 0;
		eval(text_function2);
		return v;
	}
	//非積分関数の定義（a係数の計算用）
	function fa(x, n) {
		if(BC == "Dirichlet") return f(x) * cos(2 * PI * (n-1/2) / L * x);
		else  return f(x) * cos(2 * PI * n / L * x);
	}
	//非積分関数の定義（b係数の計算用）
	function fb(x, n) {
		if(BC == "Neumann") return f(x) * sin(2 * PI * (n-1/2) / L * x);
		else return f(x) * sin(2 * PI * n / L * x);
	}
	//非積分関数の定義（c係数の計算用）
	function fc(x, n) {
		var omega = 2 * PI * n / L *v;
		if(BC == "Dirichlet") return g(x) * cos(2 * PI * (n-1/2) / L * x)/omega;
		else return g(x) * cos(2 * PI * n / L * x)/omega;
	}
	//非積分関数の定義（d係数の計算用）
	function fd(x, n) {
		var omega = 2 * PI * n / L *v;
		if(BC == "Neumann") return g(x) * sin(2 * PI * (n-1/2) / L * x)/omega;
		else return g(x) * sin(2 * PI * n / L * x)/omega;
	}
	//////////////  初期条件から展開係数の取得	///////////////////
	var MN = M * 4;    //積分→和の分割数
	var Delta_x = (x_max - x_min) / MN;//刻み幅
	//展開係数
	var An=0;
	var Bn=0;
	var Cn=0;
	var Dn=0;
	//シンプソンの公式による数値積分
	for (var n = 1; n <= MN / 2; n++) {
		var x = x_min + Delta_x * (2 * n - 1);
		An += (fa(x - Delta_x, m) + 4 * fa(x, m) + fa(x + Delta_x, m)) / 3 * Delta_x;
		Bn += (fb(x - Delta_x, m) + 4 * fb(x, m) + fb(x + Delta_x, m)) / 3 * Delta_x;
		Cn += (fc(x - Delta_x, m) + 4 * fc(x, m) + fc(x + Delta_x, m)) / 3 * Delta_x;
		Dn += (fd(x - Delta_x, m) + 4 * fd(x, m) + fd(x + Delta_x, m)) / 3 * Delta_x;
	}
	An *= 2 / L;
	Bn *= 2 / L;
	Cn *= 2 / L;
	Dn *= 2 / L;
	if(m==0){
		Cn = 0;
		Dn = 0;
		if(BC == "Dirichlet") An = 0;
	}
	

	//ホストプログラムへ計算結果を送信
	postMessage({ m: m, An:An, Bn:Bn, Cn:Cn, Dn:Dn });
}
