// WebWorker
onmessage = function(event) {
    var AA = event.data;
	var results = wavefunction(AA);
    // 生成元に結果を返す
    results.n = AA.n; //主量子数
    results.l = AA.l; //方位量子数
    results.m = AA.m; //磁気量子数 m = 0 ～ l
    postMessage(results);
}
function wavefunction(AA){
	var n = AA.n; //主量子数
    var l = AA.l; //方位量子数
    var m = AA.m; //磁気量子数 m = 0 ～ l
	var L = AA.L; //計算する領域のサイズ
	var p_max = AA.p_max; //描画する点の数
	var results = {};
	var points = new Array(); 
	points[0] = new Array();
	if(m>0){
		points[1] = new Array();
		points[2] = new Array();
	}
	if(n==1){
		times  = 5;
		timesL = L/3;
	}
	else if(n==2){
		times  = 20;
		timesL = L/2;		
	}
	else if (n==3){
		times  = 50;
		timesL = L/1.5;			  
	}
	else if (n==4){
	  times =70;
	  timesL = L;		  
	}
	//var mat = new THREE.ParticleBasicMaterial({vertexColors:true, size: p_size});
	var pointCount = p_max*100;
	//var pointGeo = new THREE.Geometry();
	var p=0;
	for (var i=0; i<pointCount; i++) {
		var x = timesL/2* (Math.random() - Math.random());
		var y = timesL/2* (Math.random() - Math.random());
		var z = timesL/2* (Math.random() - Math.random());
		
		var r = Math.sqrt(Math.pow(x,2)+Math.pow(y,2)+Math.pow(z,2));
		var theta = Math.acos(z/r);
		var phi;
		if(y>=0) phi = Math.acos(x/(r*Math.sin(theta)));
		else phi = 2.0*Math.PI - Math.acos(x/(r*Math.sin(theta)));
		if(r==0){
			theta = 0;
			phi = 0;
		}
		var R = 2.0/Math.pow(n,2) * Math.sqrt(Factorial(n-l-1)/Factorial(n+l)) * Math.exp(-r/n) * Math.pow( 2.0*r/n,l) *Laguerre(2*l+1, n-l-1, 2.0*r/n)  ;
		var Y = Math.pow(-1.0, m) * Math.sqrt(l+1.0/2.0) * Factorial(l-m)/Factorial(l+m) * Legendre(m,l,Math.cos(theta));
		var Psi, Psi_x, Psi_y;

		Psi = R * Y;
		if(Math.abs(Psi) * times  <Math.random()) continue;	
		if(m==0) {
			if(Psi>0) points[0].push({x:x,y:y,z:z,a:1});
			else points[0].push({x:x,y:y,z:z,a:-1});
		}else{
			var Yx = Y * Math.cos(m*phi);
			var Yy = Y * Math.sin(m*phi);
			Psi_x = R * Yx;
			Psi_y = R * Yy;
			if(Psi_x>0) points[1].push({x:x,y:y,z:z,a:1});
			else points[1].push({x:x,y:y,z:z,a:-1});
			if(Psi_y>0) points[2].push({x:x,y:y,z:z,a:1});
			else points[2].push({x:x,y:y,z:z,a:-1});			
		} 
		p++;
		if(p > p_max) break;
	}
	if(m==0) {	
		results.z = points[0];
	}else{
		results.x = points[1];	
		results.y = points[2];
	}
	return results;
}
	function Factorial(n, n1) //
	{
	　　var m = n1 || 1; 
	  if( n<=0 ) return (1.0);
	  var F = 1.0;
	  for(var i=n; i>=2; i-=m ){
	    F *= i;    
	  }
	  return (F);
	}
	function Legendre (m, l, x ) {//ルジャンドル陪関数
	  var mm = Math.abs(m);
	  if( mm>l )  return (0);
	  var r0, r1, r2;
	    r0 = 0.0;
	    r1 = Math.pow(1.0-x*x, mm/2.0) * Factorial(2*mm-1,2);
	    if( mm==l && m>=0) return (r1);
	    if( mm==l && m<0)  return (r1 * Math.pow(-1.0,mm) * Factorial(l-mm)/Factorial(l+mm)) ;
	    for(var ll = mm+1; ll<=l; ll++ ){
	      r2 = ((2.0*ll-1.0)*x*r1 - (ll+mm-1.0)*r0)/(ll-mm);
	      r0 = r1;
	      r1 = r2;
	    }
	  if(m>=0) return (r2);
	  else return (r2 * Math.pow(-1.0,mm) * Factorial(l-mm)/Factorial(l+mm)) ;
	}
	function Laguerre(k, n, x){
		var sum=0;
		for(var m=0; m<=n; m++){
			sum += Math.pow(-x,m)*Factorial(n+k)/Factorial(n-m)/Factorial(k+m)/Factorial(m);
		}
		return sum;
	}
